function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import PropTypes from 'prop-types';
import React, { useEffect, useReducer } from 'react';
import Context from './Context';
import reducer from './store/reducer';
import { setFilterIsOpen as _setFilterIsOpen, clearFilter as _clearFilter, setFields as _setFields, addFilterQuery as _addFilterQuery } from './store/actions';
import { getList as _getList } from './store/selectors';

function getInitState(persistKey) {
  var persistedValues = {};

  try {
    persistedValues = JSON.parse(localStorage.getItem(persistKey)) || {};
  } catch (error) {
    console.warn(error);
  }

  return persistedValues;
}

var Provider = function Provider(_ref) {
  var children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'mui_filter' : _ref$persistKey;

  var _useReducer = useReducer(reducer, getInitState(persistKey)),
      state = _useReducer[0],
      dispatch = _useReducer[1];

  console.log('state', state);
  useEffect(function () {
    try {
      var stateToSave = {};
      Object.keys(state).map(function (k) {
        var _state$k = state[k],
            fields = _state$k.fields,
            rest = _objectWithoutPropertiesLoose(_state$k, ["fields"]);

        stateToSave[k] = rest;
      });
      localStorage.setItem(persistKey, JSON.stringify(stateToSave));
    } catch (error) {
      console.warn(error);
    }
  }, [state, persistKey]);
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      setFilterIsOpen: function setFilterIsOpen(name, isOpen) {
        return dispatch(_setFilterIsOpen(name, isOpen));
      },
      openFilter: function openFilter(name) {
        return dispatch(_setFilterIsOpen(name, true));
      },
      closeFilter: function closeFilter(name) {
        return dispatch(_setFilterIsOpen(name, false));
      },
      clearFilter: function clearFilter(name) {
        return dispatch(_clearFilter(name));
      },
      setFields: function setFields(name, fields) {
        return dispatch(_setFields(name, fields));
      },
      addFilterQuery: function addFilterQuery(name, query) {
        return dispatch(_addFilterQuery(name, query));
      },
      getList: function getList(name, list) {
        return _getList(state[name], list);
      }
    }
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any,
  firebaseApp: PropTypes.any
} : {};
export default Provider;