"use strict";

exports.__esModule = true;
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Context = _interopRequireDefault(require("./Context"));

var _reducer = _interopRequireDefault(require("./store/reducer"));

var _actions = require("./store/actions");

var _selectors = require("./store/selectors");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function getInitState(persistKey) {
  var persistedValues = {};

  try {
    persistedValues = JSON.parse(localStorage.getItem(persistKey)) || {};
  } catch (error) {
    console.warn(error);
  }

  return persistedValues;
}

var Provider = function Provider(_ref) {
  var children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'mui_filter' : _ref$persistKey;

  var _useReducer = (0, _react.useReducer)(_reducer.default, getInitState(persistKey)),
      state = _useReducer[0],
      dispatch = _useReducer[1];

  console.log('state', state);
  (0, _react.useEffect)(function () {
    try {
      var stateToSave = {};
      Object.keys(state).map(function (k) {
        var _state$k = state[k],
            fields = _state$k.fields,
            rest = _objectWithoutPropertiesLoose(_state$k, ["fields"]);

        stateToSave[k] = rest;
      });
      localStorage.setItem(persistKey, JSON.stringify(stateToSave));
    } catch (error) {
      console.warn(error);
    }
  }, [state, persistKey]);
  return /*#__PURE__*/_react.default.createElement(_Context.default.Provider, {
    value: {
      setFilterIsOpen: function setFilterIsOpen(name, isOpen) {
        return dispatch((0, _actions.setFilterIsOpen)(name, isOpen));
      },
      openFilter: function openFilter(name) {
        return dispatch((0, _actions.setFilterIsOpen)(name, true));
      },
      closeFilter: function closeFilter(name) {
        return dispatch((0, _actions.setFilterIsOpen)(name, false));
      },
      clearFilter: function clearFilter(name) {
        return dispatch((0, _actions.clearFilter)(name));
      },
      setFields: function setFields(name, fields) {
        return dispatch((0, _actions.setFields)(name, fields));
      },
      addFilterQuery: function addFilterQuery(name, query) {
        return dispatch((0, _actions.addFilterQuery)(name, query));
      },
      getList: function getList(name, list) {
        return (0, _selectors.getList)(state[name], list);
      }
    }
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.any,
  firebaseApp: _propTypes.default.any
} : {};
var _default = Provider;
exports.default = _default;
module.exports = exports.default;